`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2018/03/29 20:12:21
// Design Name: 
// Module Name: FSM
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////



`define FIRST_num_MSB 4'b0000
`define transition_0 4'b0001
`define FIRST_num_LSB 4'b0010
`define transition_1 4'b0011
`define operator 4'b0100
`define transition_2 4'b0101
`define SECOND_num_MSB 4'b0110
`define transition_3 4'b0111
`define SECOND_num_LSB 4'b1000
`define transition_4 4'b1001
`define show_answer 4'b1010
`define transition_5 4'b1011  //show answer release
module FSM(
in, //input control
clk, // global clock signal
rst, // high active reset
state,
firstnum_MSB,
firstnum_LSB,
secondnum_MSB,
secondnum_LSB,
Operator,
Result,
Keyboard_in,
last_changed
);

// inputs
input [8:0]last_changed;
input clk; // global clock signal
input rst; // high active reset
input in; //input control
input [3:0]Keyboard_in;
output reg [12:0]Result;
output reg [3:0]firstnum_MSB, firstnum_LSB, secondnum_MSB, secondnum_LSB;
reg [3:0]firstnum_MSB_tmp, firstnum_LSB_tmp, secondnum_MSB_tmp, secondnum_LSB_tmp;
reg [3:0]Operator_tmp;
output reg [3:0]Operator;
reg [12:0]Result_tmp;
wire [12:0]Calculation_Result;
reg [3:0]Result_3, Result_2, Result_1, Result_0;
output reg [3:0]state; // state of FSM
reg [3:0]next_state; // next state of FSM
reg [6:0]a, b;

// FSM state decision
always @*
  case (state)
    `FIRST_num_MSB:
    if (in && last_changed != 9'h05A)
        begin
            next_state = `transition_0;
            firstnum_MSB_tmp = Keyboard_in;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;  //useless
            secondnum_LSB_tmp = secondnum_LSB;  //useless
            Operator_tmp = Operator;                //useless
            Result_tmp = 13'd0;                 //useless
        end
    else
        begin
            next_state = `FIRST_num_MSB;
            firstnum_MSB_tmp = firstnum_MSB;   //useless   
            firstnum_LSB_tmp = firstnum_LSB;   //useless
            secondnum_MSB_tmp = secondnum_MSB; //useless   
            secondnum_LSB_tmp = secondnum_LSB; //useless   
            Operator_tmp = Operator;               //useless
            Result_tmp = Result;                //useless   
        end
    `transition_0:
    if (in && last_changed != 9'h05A)
        begin
            next_state = `FIRST_num_LSB;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //useless   
        end
    else
        begin
            next_state = `transition_0;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //useless   
        end
   `FIRST_num_LSB:
    if (in && last_changed != 9'h05A)
         begin 
            next_state = `transition_1;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = Keyboard_in;    //useless
            secondnum_MSB_tmp = secondnum_MSB;  //useless
            secondnum_LSB_tmp = secondnum_LSB;  //useless
            Operator_tmp = Operator;                //useless
            Result_tmp = 13'd0;                 //useless
         end
    else
         begin
             next_state = `FIRST_num_LSB;
             firstnum_MSB_tmp = firstnum_MSB;   //useless   
             firstnum_LSB_tmp = firstnum_LSB;   //useless
             secondnum_MSB_tmp = secondnum_MSB; //useless   
             secondnum_LSB_tmp = secondnum_LSB; //useless   
             Operator_tmp = Operator;               //useless
             Result_tmp = 13'd0;                //useless   
         end
    `transition_1:
    if (in && last_changed != 9'h05A)
         begin
         next_state = `operator;
         firstnum_MSB_tmp = firstnum_MSB;
         firstnum_LSB_tmp = firstnum_LSB;    //useless
         secondnum_MSB_tmp = secondnum_MSB;
         secondnum_LSB_tmp = secondnum_LSB;
         Operator_tmp = Operator;               //useless
         Result_tmp = 13'd0;                //usele
         end
    else
         begin
            next_state = `transition_1;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //usele
         end
   `operator:
    if (in && last_changed != 9'h05A)
        begin
            next_state = `transition_2;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Keyboard_in;               //useless
            Result_tmp = 13'd0;                //usele
        end
    else
        begin
            next_state = `operator;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //usele
        end
  `transition_2:
   if (in && last_changed != 9'h05A)
        begin
            next_state = `SECOND_num_MSB;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //usele
        end
    else
      begin
            next_state = `transition_2;
            firstnum_MSB_tmp = firstnum_MSB;
            firstnum_LSB_tmp = firstnum_LSB;    //useless
            secondnum_MSB_tmp = secondnum_MSB;
            secondnum_LSB_tmp = secondnum_LSB;
            Operator_tmp = Operator;               //useless
            Result_tmp = 13'd0;                //usele
      end
  `SECOND_num_MSB:
    if (in && last_changed != 9'h05A)
        begin
            next_state = `transition_3;
            firstnum_MSB_tmp =  firstnum_MSB;
            firstnum_LSB_tmp =  firstnum_LSB;    //useless
            secondnum_MSB_tmp = Keyboard_in;  //useless
            secondnum_LSB_tmp = secondnum_LSB;  //useless
            Operator_tmp = Operator;                //useless
            Result_tmp = 13'd0;                 //useless
        end
    else
        begin
            next_state = `SECOND_num_MSB;
            firstnum_MSB_tmp = firstnum_MSB;   //useless   
            firstnum_LSB_tmp = firstnum_LSB;   //useless
            secondnum_MSB_tmp = secondnum_MSB; //useless   
            secondnum_LSB_tmp = secondnum_LSB; //useless   
            Operator_tmp = Operator;               //useless
            Result_tmp =  13'd0;                //useless   
         end
  `transition_3:
    if (in && last_changed != 9'h05A)
         begin
             next_state = `SECOND_num_LSB;
             firstnum_MSB_tmp = firstnum_MSB;
             firstnum_LSB_tmp = firstnum_LSB;    //useless
             secondnum_MSB_tmp = secondnum_MSB;
             secondnum_LSB_tmp = secondnum_LSB;
             Operator_tmp = Operator;               //useless
             Result_tmp = 13'd0;                //usele
         end
    else
        begin
             next_state = `transition_3;
             firstnum_MSB_tmp = firstnum_MSB;
             firstnum_LSB_tmp = firstnum_LSB;    //useless
             secondnum_MSB_tmp = secondnum_MSB;
             secondnum_LSB_tmp = secondnum_LSB;
             Operator_tmp = Operator;               //useless
             Result_tmp = 13'd0;                //usele
        end
  `SECOND_num_LSB:
    if (in && last_changed != 9'h05A)
          begin 
             next_state = `transition_4;
             firstnum_MSB_tmp = firstnum_MSB;
             firstnum_LSB_tmp = firstnum_LSB;    //useless
             secondnum_MSB_tmp = secondnum_MSB;  //useless
             secondnum_LSB_tmp = Keyboard_in;  //useless
             Operator_tmp = Operator;                //useless
             Result_tmp = 13'd0;                 //useless
          end
    else
          begin
              next_state = `SECOND_num_LSB;
              firstnum_MSB_tmp = firstnum_MSB;   //useless   
              firstnum_LSB_tmp = firstnum_LSB;   //useless
              secondnum_MSB_tmp = secondnum_MSB; //useless   
              secondnum_LSB_tmp = secondnum_LSB; //useless   
              Operator_tmp = Operator;               //useless
              Result_tmp = 13'd0;                //useless   
          end
  `transition_4:
    if (in && last_changed != 9'h05A)
          begin
              next_state = `show_answer;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = 13'd0;                //usele
          end
    else
         begin
              next_state = `transition_4;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = 13'd0;                //usele
         end
 `show_answer:                                       //To calculate the result !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! And press Enter
   if (in  && last_changed == 9'h05A)
          begin
              next_state = `transition_5;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = Calculation_Result;                //usele
          end
    else
         begin
              next_state = `show_answer;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = Calculation_Result;                //usele
         end
 `transition_5:
     if (in && last_changed == 9'h05A)
          begin
              next_state = `FIRST_num_MSB;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = Result;                //usele
          end
    else
         begin
              next_state = `transition_5;
              firstnum_MSB_tmp = firstnum_MSB;
              firstnum_LSB_tmp = firstnum_LSB;    //useless
              secondnum_MSB_tmp = secondnum_MSB;
              secondnum_LSB_tmp = secondnum_LSB;
              Operator_tmp = Operator;               //useless
              Result_tmp = Result;                //usele
         end
  default:  //useless
      if (in && last_changed != 9'h05A)
           begin
               next_state = `FIRST_num_MSB;
               firstnum_MSB_tmp = firstnum_MSB;
               firstnum_LSB_tmp = firstnum_LSB;       //useless
               secondnum_MSB_tmp = secondnum_MSB;
               secondnum_LSB_tmp = secondnum_LSB;
               Operator_tmp = Operator;               //useless
               Result_tmp = Result;                   //usele
           end
     else
          begin
               next_state = `transition_5;
               firstnum_MSB_tmp = firstnum_MSB;       //useless  
               firstnum_LSB_tmp = firstnum_LSB;       //useless
               secondnum_MSB_tmp = secondnum_MSB;     //useless
               secondnum_LSB_tmp = secondnum_LSB;     //useless
               Operator_tmp = Operator;               //useless
               Result_tmp = Result;                   //useless
          end
    endcase
    
always @*
    begin
        a = firstnum_MSB*10+firstnum_LSB;   
        b = secondnum_MSB*10+secondnum_LSB;   
    end
    Calculation U0(
        .operator(Operator),
        .a(a),
        .b(b),
        .result(Calculation_Result)
     );
    // FSM state transition
always @(posedge clk or posedge rst)
    if (rst)
        state <= `FIRST_num_MSB;
    else
        state <= next_state;
        
always @(posedge clk or posedge rst)
    if(rst)
        begin
            firstnum_MSB <= 4'd0;
            firstnum_LSB <= 4'd0;
            secondnum_MSB <= 4'd0;
            secondnum_LSB <= 4'd0; 
            Operator <= 4'd0;
            Result <= 4'd0;     
        end
    else
        begin
            firstnum_MSB <= firstnum_MSB_tmp;
            firstnum_LSB <= firstnum_LSB_tmp;
            secondnum_MSB <= secondnum_MSB_tmp;
            secondnum_LSB <= secondnum_LSB_tmp;     
            Operator <= Operator_tmp; 
            Result <= Result_tmp;
        end
    
    endmodule
